import 'package:jaguar/jaguar.dart';
import 'package:jaguar_auth/jaguar_auth.dart';

import 'model.dart';

/// Model manager to authenticate against a static list of user models
class WhiteListPasswordChecker implements UserFetcher<User> {
  /// User models to white list
  final Map<String, User> models;

  const WhiteListPasswordChecker(Map<String, User> models, {Hasher hasher})
      : models = models ?? const {};

  User getByAuthenticationId(Context ctx, String username) => models.values
      .firstWhere((model) => model.username == username, orElse: () => null);

  User getByAuthorizationId(Context ctx, String id) => models[id];
}
